
INSERT INTO Building_ResourceYieldChanges(BuildingType, ResourceType, YieldType, Yield)
	SELECT ('BUILDING_MM_FARMERS_MARKET'), Type, ('YIELD_GOLD'), 1
	FROM Resources WHERE Happiness = 0;


CREATE TRIGGER MMFarmersMarket_ResourceAdd
AFTER INSERT ON Resources
WHEN NEW.Happiness = 0
BEGIN
	INSERT INTO Building_ResourceYieldChanges(BuildingType, ResourceType, YieldType, Yield)
	VALUES('BUILDING_MM_FARMERS_MARKET', NEW.Type, 'YIELD_GOLD', 1);
END;


CREATE TRIGGER MMFarmersMarket_ResourceChangeB
AFTER UPDATE ON Resources
WHEN OLD.Happiness > 0 AND NEW.Happiness = 0
BEGIN
	INSERT INTO Building_ResourceYieldChanges(BuildingType, ResourceType, YieldType, Yield)
	VALUES('BUILDING_MM_FARMERS_MARKET', NEW.Type, 'YIELD_GOLD', 1);
END;


CREATE TRIGGER MMFarmersMarket_ResourceChangeL
AFTER UPDATE ON Resources
WHEN OLD.Happiness = 0 AND NEW.Happiness > 0
BEGIN
	DELETE FROM Building_ResourceYieldChanges
	WHERE ResourceType = NEW.Type AND BuildingType = 'BUILDING_MM_FARMERS_MARKET';
END;


CREATE TRIGGER MMFarmersMarket_ResourceDelete
AFTER DELETE ON Resources
BEGIN
	DELETE FROM Building_ResourceYieldChanges
	WHERE ResourceType = OLD.Type AND BuildingType = 'BUILDING_MM_FARMERS_MARKET';
END;