-- MMGrassGlobals
-- Author: Marius
-- DateCreated: 8/23/2019 9:28:44 PM
--------------------------------------------------------------
include "UniqueDiplomacyUtilsV3.lua"

g_tSavedData = Modding.OpenSaveData()

gMMgold = GameInfoTypes.BUILDING_MM_CS_GOLD
g_tAdventurer = {
	[GameInfoTypes.UNIT_MM_ADVENTURER] = true,
--	[GameInfoTypes.UNIT_MM_ADVENTURER_TREASURY] = true
	}
gAdventurerPromo = GameInfoTypes.PROMOTION_MM_ADVENT


--Improvements
gFarm = GameInfoTypes.IMPROVEMENT_FARM_MM_ADV 
gMine = GameInfoTypes.IMPROVEMENT_MINE_MM_ADV 
gCamp = GameInfoTypes.IMPROVEMENT_CAMP_MM_ADV 

gAgriculture = GameInfoTypes.TECH_AGRICULTURE
gMining = GameInfoTypes.TECH_MINING
gTrapping = GameInfoTypes.TECH_TRAPPING


gMineBarbarian = GameInfoTypes.PROMOTION_NAVAL_TRADITION --We distinguish a barbarian as a special event one
--by giving it a promotion it will almost never, EVER have
gCampBarbarian = GameInfoTypes.PROMOTION_GREAT_LIGHTHOUSE


tBarbarians = {
	[gMine] = {},
	[gCamp] = {},
	}

table.insert(tBarbarians[gMine], GameInfoTypes.UNIT_BARBARIAN_WARRIOR)
table.insert(tBarbarians[gMine], GameInfoTypes.UNIT_BARBARIAN_AXMAN)
table.insert(tBarbarians[gMine], GameInfoTypes.UNIT_DANISH_BERSERKER)
table.insert(tBarbarians[gMine], GameInfoTypes.UNIT_BARBARIAN_SPEARMAN)
table.insert(tBarbarians[gMine], GameInfoTypes.UNIT_SIAMESE_ELEPHANT)

table.insert(tBarbarians[gCamp], GameInfoTypes.UNIT_BARBARIAN_WARRIOR)
table.insert(tBarbarians[gCamp], GameInfoTypes.UNIT_BARBARIAN_AXMAN)
table.insert(tBarbarians[gCamp], GameInfoTypes.UNIT_BARBARIAN_ARCHER)
table.insert(tBarbarians[gCamp], GameInfoTypes.UNIT_BARBARIAN_HORSEMAN)
table.insert(tBarbarians[gCamp], GameInfoTypes.UNIT_HUN_HORSE_ARCHER)

tMineResources = {}
for row in DB.Query("SELECT * FROM Improvement_ResourceTypes WHERE ImprovementType = 'IMPROVEMENT_MINE_MM_ADV'") do
	table.insert(tMineResources, row.ResourceType)
end 
									
									

gGrassDefense = GameInfoTypes.BUILDING_MM_GRASS_DEFENSE
gGrassGold = GameInfoTypes.BUILDING_MM_CS_GOLD

--Adventurer's Treasury
gAdventureTreasury = GameInfoTypes.BUILDING_MM_ADVENTURE_TREASURY
gTreasuryGold = GameInfoTypes.BUILDING_MM_TREASURY_DISCOUNT
g_tTreasuries = {}
--Farmer's Market
gFarmersMarket = GameInfoTypes.BUILDING_MM_FARMERS_MARKET
gFarmersBonus = GameInfoTypes.BUILDING_MM_FARMERS_BONUS
--Gauntlet
gGauntlet = GameInfoTypes.BUILDING_MM_GAUNTLET
gGauntletRuins = GameInfoTypes.BUILDING_MM_GAUNTLET_RUINS
gGauntletSalvage = GameInfoTypes.BUILDING_MM_GAUNTLET_SALVAGE
gGauntletPromo = GameInfoTypes.PROMOTION_MM_GAUNTLET
gAdventurerPromo = GameInfoTypes.PROMOTION_MM_ADVENT


gCBP = false

for row in DB.Query("SELECT Value FROM COMMUNITY WHERE Type = 'COMMUNITY_CORE_BALANCE_CIVS'") do
	gCBP = row.Value == 1
end


bMMDebug = true
function dprint(...)
	if (bMMDebug) then print(...) end
end

dprint(gCBP)
----------------------------------------------
--GetNumProtectingMinors
--Iterates through all city states in the game
--Determines how many minors iPlayer is protecting
----------------------------------------------
function GetNumProtectingMinors(iPlayer)
	local iMinors = 0
	for iMinor = GameDefines.MAX_MAJOR_CIVS - 1, GameDefines.MAX_CIV_PLAYERS - 1, 1 do
		 local pMinor = Players[iMinor]
		 if pMinor:IsEverAlive() and pMinor:IsAlive() then
			local pCapital = pMinor:GetCapitalCity()
			if pMinor:IsProtectedByMajor(iPlayer) then
		--	if pMinor:GetAlly() == iPlayer then
				iMinors = iMinors + 1
				if pCapital then
					pCapital:SetNumRealBuilding(gGrassDefense, 5)
				end
			elseif pCapital then
				pCapital:SetNumRealBuilding(gGrassDefense, 0)
			end
		end
	end
	return iMinors
end

-------------------------------
--IsGrasslands
--Determines if iPlayer is the Grasslands
-------------------------------
function IsGrasslands(iPlayer)
return Players[iPlayer]:GetCivilizationType() == GameInfoTypes.CIVILIZATION_MM_GRASS end

----------------------------------------------------------------
--SpawnBarbarians
--Creates a set number of random barbs
--based on the context of the improvement built
----------------------------------------------------------------
function SpawnBarbarians(x, y, iBarbariansToSpawn, eImprovement)
	if iBarbariansToSpawn > 0 then
		SpawnBarbarians(x, y, iBarbariansToSpawn - 1, eImprovement)
		local iRoll = Game.Rand(100, "Finn Roll")
		if iRoll < 60 then iRoll = 1
		elseif iRoll < 90 then iRoll = 2
		else iRoll = 3
		end
		local pUnit = Players[63]:InitUnit(tBarbarians[eImprovement][iRoll], x, y, UNITAI_ATTACK)
		if eImprovement == gMine then
			pUnit:SetHasPromotion(gMineBarbarian, true)
		else
			pUnit:SetHasPromotion(gCampBarbarian, true)
		end
		pUnit:JumpToNearestValidPlot()
	end
end
--------------------------------------
--GetNearestCity
--Finds the closest city belonging to iPlayer from x, y
--------------------------------------
function GetNearestCity(iPlayer, x, y)
	dprint("Getting closest city from " .. x .. " " .. y)
	local iDistance = Map.GetNumPlots()
	local iNearestCity = 0
	for pCity in Players[iPlayer]:Cities() do
		if Map.PlotDistance(pCity:GetX(), pCity:GetY(), x, y) < iDistance then
			iDistance = Map.PlotDistance(pCity:GetX(), pCity:GetY(), x, y)
			iNearestCity = pCity:GetID()
		end
	end
	return iNearestCity
end

--------------------------------------------------------------------
--DetermineExtraImprovementBonus
--This one is a doozy
--It's pretty much the AttemptPSI of this mod
--Rolls a random number, and based on that number and the improvement built, does something (or nothing)
--------------------------------------------------------------------
function DetermineExtraImprovementBonus(iPlayer, x, y, eImprovement)
	local iRoll = Game.Rand(100, "Finn Roll")
	dprint("Player " .. iPlayer .. " rolled a " .. iRoll)
	--%50 chance nothing will happen
	if iRoll < 50 then return end
	local pPlayer = Players[iPlayer]
	--5% chance
	if iRoll < 55 then
		--Settler appears
		if eImprovement == gFarm then
			pPlayer:InitUnit(GameInfoTypes.UNIT_SETTLER, x, y, UNITAI_SETTLE)
			pPlayer:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, "Rad! The farm created by your Adventurer has attracted some friendly settlers, happy to make the fertile land their new home!", "A settler!", x, y)
		--Resource Appears
		elseif eImprovement == gMine then 
			if Map.GetPlot(x, y):GetResourceType(-1) == -1 then
				local eResource = GameInfo[tMineResources[Game.Rand(#tMineResources, "Finn Roll")]].ID
				Map.GetPlot(x, y):SetResourceType(eResource, 1)
				pPlayer:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, "Your Adventurer managed to uncover a vein of " .. Locale.ConvertTextKey(GameInfo.Resources[eResource].Description) .. ". Math!", "Resource discovered!", x, y)
			else
				local pCity = pPlayer:GetCityByID(GetNearestCity(iPlayer, x, y))
					if pCity then
					local iProduction = 14
					pCity:SetOverflowProduction(pCity:GetOverflowProduction() + iProduction)
					pPlayer:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, "Your Adventurers find some resources that could prove useful in " .. pCity:GetName() .. "'s current project. The city has received a small " .. Locale.ConvertTextKey("[ICON_PRODUCTION]") .. " Prodcution boost!", "Production!", x, y)
				end
			end
		--Faith
		else
			pPlayer:ChangeFaith(20)
			pPlayer:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, "Your Adventurer's camp is visited by an elderly wizard, who shares many a secret of the ways of wizarding. +20 " .. Locale.ConvertTextKey("[ICON_PEACE]") .. " Faith!", "Wizard!", x, y)
		end
	--5% chance
	elseif iRoll < 60 then
		--Population in nearest city
		if eImprovement == gFarm then
			local pCity = pPlayer:GetCityByID(GetNearestCity(iPlayer, x, y))
			if pCity then
				pCity:ChangePopulation(1, true)
				pPlayer:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, "The farm your Adventurer created attracts the attention of some local folk. They are taken aback by your humbleness, and happily move into " .. pCity:GetName() .. ", increasing its Population by 1!", "New peeps!", x, y)
			end

		--Production in nearest city
		elseif eImprovement == gMine then
			local pCity = pPlayer:GetCityByID(GetNearestCity(iPlayer, x, y))
			if pCity then
				local iProduction = 14
				pCity:SetOverflowProduction(pCity:GetOverflowProduction() + iProduction)
				pPlayer:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, "Your Adventurers find some resources that could prove useful in " .. pCity:GetName() .. "'s current project. The city has received a small " .. Locale.ConvertTextKey("[ICON_PRODUCTION]") .. " Prodcution boost!", "Production!", x, y)
			end
		--Food boost in nearest city
		else
			local pCity = pPlayer:GetCityByID(GetNearestCity(iPlayer, x, y))
			if pCity then
				local iFood = 3
				pCity:ChangeFood(iFood)
				pPlayer:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, "Your Adventurers manage to make a relatively succesful hunt. They have sent excess " .. Locale.ConvertTextKey("[ICON_FOOD]") .. " Food back to " .. pCity:GetName() .. "!", "Hunting Time!", x, y)
			end
		end
	--15%
	elseif iRoll < 75 then
		--Wheat appears
		if eImprovement == gFarm then
			if Map.GetPlot(x, y):GetResourceType(-1) == -1 then
				Map.GetPlot(x, y):SetResourceType(GameInfoTypes.RESOURCE_WHEAT, 1)
				pPlayer:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, "The farm started by your Adventurer has proven to be rather fertile! Wheat has begun growing in the area in mass!", "Farming time!", x, y)
			else 
				local pCity = pPlayer:GetCityByID(GetNearestCity(iPlayer, x, y))
				if pCity then
					local iFood = 5
					pCity:ChangeFood(iFood)
					pPlayer:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, "Excess harvests are sent as " .. iFood .. " " .. Locale.ConvertTextKey("[ICON_FOOD]") .. " Food back to " .. pCity:GetName() .. "!", "Farming Time!", x, y)
				end
			end
		--Barbarians appear
		elseif eImprovement == gMine then
			local iNumUnits = math.floor((Game.Rand(15, "Finn Roll") + 1) / 3)
			if iNumUnits == 0 then iNumUnits = 1 end
			dprint("Spawning " .. iNumUnits .. " barbarians")
			SpawnBarbarians(x, y, iNumUnits, eImprovement)
			pPlayer:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, "Your Adventurer managed to uncover a hidden dungeon, from which some evil monsters emerge! You know what time it is!", "Bad Guy Fighting Time!", x, y)
		--Barbarians appear
		else
			local iNumUnits = math.floor((Game.Rand(15, "Finn Roll") + 1) / 3)
			if iNumUnits == 0 then iNumUnits = 1 end
			dprint("Spawning " .. iNumUnits .. " barbarians")
			SpawnBarbarians(x, y, iNumUnits, eImprovement)
			pPlayer:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, "Your Adventurers' camp is ambushed by evil barbarians!", "Bad Guy Fighting Time!", x, y)
		end
	--%25 chance
	else
		--Food in nearest city
		if eImprovement == gFarm then
			local pCity = pPlayer:GetCityByID(GetNearestCity(iPlayer, x, y))
			if pCity then
				local iFood = 10
				pCity:ChangeFood(iFood)
				pPlayer:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, "Excess harvests are sent as " .. iFood .. " " .. Locale.ConvertTextKey("[ICON_FOOD]") .. " Food back to " .. pCity:GetName() .. "!", "Farming Time!", x, y)
			end
		--Gold
		elseif eImprovement == gMine then
			local iGold = 20
			pPlayer:ChangeGold(iGold)
			pPlayer:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, "Within the mines your Adventurer find some valuable trinkets. + " .. iGold .. " " .. Locale.ConvertTextKey("[ICON_GOLD]") .. " Gold", "Mining Time!", x, y)
		--Culture or Survivalism
		else
			local bCulture = true
			local pPlot = Map.GetPlot(x, y)
			for i = 0, pPlot:GetNumUnits() - 1 do
				local pUnit = pPlot:GetUnit(i)
				if g_tAdventurer[pUnit:GetUnitType()] and pUnit:GetOwner() == iPlayer and not pUnit:IsHasPromotion(GameInfoTypes.PROMOTION_SURVIVALISM_2) then
					pUnit:SetHasPromotion(GameInfoTypes.PROMOTION_SURVIVALISM_2, true)
					bCulture = false
				end
			end
			if bCulture then
				local iCulture = 10
				pPlayer:ChangeJONSCulture(iCulture)
				pPlayer:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, "With their camp complete, your Adventurers throw an all-out party! +" .. iCulture .. " " .. Locale.ConvertTextKey("[ICON_CULTURE]"), "Party time!", x, y)
			else pPlayer:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, "Your Adventurer has greatly improved their ability to survive outside of civilization. They have learned Surivialism II!", "Adventurer's New Skill", x, y)
			end
		end
	end	
end

function FarmersMarketBonus(tTradeRoutes)
	for k, v in pairs(tTradeRoutes) do
		if Players[v.ToID]:IsMinorCiv() and v.FromCity:IsHasBuilding(gFarmersMarket) then
			local i = (v.FromGPT / 100) / 4
			dprint("Giving " .. v.FromCityName .. " " .. i .. " Food and Production")

			v.FromCity:SetNumRealBuilding(gFarmersBonus, v.FromCity:GetNumRealBuilding(gFarmersBonus) + i)
		end
	end	
end

function OnGauntletBuilt(iPlayer, iCity, eBuilding)
	if eBuilding == gGauntlet then
		g_tSavedData.SetValue("CITY_" .. iCity .. "_GAUNTLET", 0)
		return
	end
	
	local pCity = Players[iPlayer]:GetCityByID(iCity)
	if eBuilding == gGauntletSalvage then
		g_tSavedData.SetValue("CITY_" .. iCity .. "_GAUNTLET", 0)
		pCity:SetNumRealBuilding(gGauntletRuins, 0)
		pCity:SetNumRealBuilding(gGauntletSalvage, 0)
		pCity:SetNumRealBuilding(gGauntlet, 1)
	end
end

function DetermineGauntletStatus(pCity)
	local iUses = g_tSavedData.GetValue("CITY_" .. pCity:GetID() .. "_GAUNTLET")
	iUses = iUses + 1
	g_tSavedData.SetValue("CITY_" .. pCity:GetID() .. "_GAUNTLET", iUses)
	dprint(pCity:GetName() .. " has used its Gauntlet " .. iUses .. " times")
	if iUses >= 3 then
		local iRoll = Game.Rand(100, "Finn Roll")
		if iRoll < math.floor(33 + 3.333 * (iUses - 3)) then
			pCity:SetNumRealBuilding(gGauntlet, 0)
			pCity:SetNumRealBuilding(gGauntletRuins, 1)
			Players[pCity:GetOwner()]:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, pCity:GetName() .. "'s Gauntlet has fallen into disrepair!", "Gauntlet Ruins!", pCity:GetX(), pCity:GetY())
		end
	end
end 

function GrasslandsInit()
	for i = 0, GameDefines.MAX_MAJOR_CIVS, 1 do
		if IsGrasslands(i) and Players[i]:IsEverAlive() then
			g_tTreasuries[i] = 0
			local pPlayer = Players[i]
			if not pPlayer:IsHuman() then InjectFinnUniqueDiplo() end
			local pTeam = Teams[pPlayer:GetTeam()]
			pTeam:GetTeamTechs():SetHasTech(gAgriculture, false, iPlayer, false, false)
			pTeam:GetTeamTechs():SetHasTech(GameInfoTypes.TECH_FARM_MM_ADV, true, iPlayer, false, false)
			pTeam:GetTeamTechs():SetHasTech(gAgriculture, true, iPlayer, false, true)
		end
	end
end

-- ============================================================================
-- SubstituteEndNumberForPercentSign
-- ============================================================================
-- From VV - Replaces the number at the end of a text tag to a percentage sign
function SubstituteEndNumberForPercentSign(sString)
--	dprint("String before substitution: "..sString)
	local sReverse = string.reverse(sString)
	local iStop = string.find(sReverse, "_")
	if not iStop then return sString end
	sReverse = string.sub(sReverse, iStop + 1)
	sString = string.reverse(sReverse).."%"
--	dprint("String after substitution: "..sString)
	return sString
end
---------------------------------
--InjectFinnUniqueDiplo
--When a Finn AI is detected, this is called
--It checks if any human players are playing as civs that have unique dialogue for them
--And injects it
---------------------------------
tFinnUniqueLeaders = {
	["LEADER_SIMON"] = true,
	["LEADER_BONNIBEL"] = true,
	["LEADER_FLAME"] = true,
	["LEADER_MARCELINE"] = true,
	["LEADER_LEMONGRAB"] = true,
}
function InjectFinnUniqueDiplo()
	for iPlayer = 0, GameDefines.MAX_MAJOR_CIVS - 1 do
		local pPlayer = Players[iPlayer]
		if pPlayer:IsEverAlive() then
			local eLeader = GameInfo.Leaders[pPlayer:GetLeaderType()].Type
			if pPlayer:IsHuman() and tFinnUniqueLeaders[eLeader] then
				local sLeader = string.sub(eLeader, 7, string.len(eLeader ))
				local tResponses = {}
				--I see many people do ChangeDiplomacyResponse manually, but that seems like too much of a hassle
				--As you'll need to add more code in lua everytime you add a new response you want to replace
				--This method is just 'set it and forget it', I just and add my lines in XML and that's that
				--TODO: consider supporting other languages for this Query
				for row in DB.Query("SELECT * FROM Language_en_US WHERE Tag LIKE ('TXT_KEY_LEADER_MM_FINN_TO" .. sLeader .. "%')") do
				--26
					local sTag = SubstituteEndNumberForPercentSign(row.Tag)
					if not tResponses[sTag] then
					
						tResponses[sTag] = true
						--When I do unique dialog, I always follow the same cadence I did for the line I am replacing
						--That is the only way this Query will work
						--What we're doing is we're cutting out the middle section of 'TXT_KEY_LEADER_MM_FINN_TO_LEADERNAME_RESPONSE%'
						--To just be 'TXT_LEADER_MM_FINN_RESPONSE%'
						--That way we can find the orignal ResponseType this line is meant to replace
						--print(string.sub(row.Tag, string.find(row.Tag, "TO") + string.len(sLeader) + 2, string.len(row.Tag) - 2))
						for subrow in DB.Query("SELECT * FROM Diplomacy_Responses WHERE Response LIKE ('TXT_KEY_LEADER_MM_FINN" .. string.sub(sTag, string.find(sTag, "TO") + string.len(sLeader) + 2, string.len(sTag)) .. "')") do
							ChangeDiplomacyResponse("LEADER_MM_FINN", subrow.ResponseType, sTag)
						end
					end
				end
				--Remove this leader from UniqueLeaders to help prevent redundant calls to ChangeDiplomacyResponse
				tFinnUniqueLeaders[eLeader] = nil	
			end
		end
	end
end

GrasslandsInit()

